/*
webserv.c: Web server for I-8000 series
Compiler: BC++ 3.1,
          Turbo C++ 1.01(3.01)

Compile mode: Large

Project: webserv.c
         ..\lib\8000e.Lib
         ..\lib\tcpip32.lib
         ..\lib\FW_nnnnn.LIB
         
Hordware: I-8000

[Jun 20, 2010] by Liam
[Aug,02,2011] by Nicholas
*/

#include <stdlib.h>
#include <stdio.h>
#include "..\lib\8000e.h"
#include "..\lib\Tcpip32.h"
#include "..\lib\MFW.h"

char *GetModuleName(void)   // User's program must support this function for UDP search
{
    return "I-8000" ;
}

char *GetAliasName(void)    // User's program must support this function for UDP search 
{
    return "test1" ;
}

void cgi_fun(int skt)
{
    int i;
    
    TcpPrint(skt, 0, "<html><head><title></title><head>"
                     "<body bgcolor='#F1F1F1'><center>\n");
    
    if(Argc>1)
    {
        for(i=1; i<Argc; i++)
        {
			if(!strcmp(Argv[i], "status=on"))
                TcpPrint(skt, 0, "<img src='on.gif' border='0' />\n");
            else if(!strcmp(Argv[i], "status=off"))
                TcpPrint(skt, 0, "<img src='off.gif' border='0' />\n");
        }
    }
    TcpPrint(skt, 0, "<a href='index.htm'><h4>Back</h4></a>\n");
    TcpPrint(skt, 1, "</center></body></html>");
    
    XS_CloseSocket(skt);
}

void XS_UserInit(int argc, char *argv[])
{
    extern int bAcceptBroadcast;
    extern unsigned long ACKDELAY;  // variable in tcp.c
    extern long MAXTXTOUT;
    void UserLoop(void);
    
    InitLib();

    bAcceptBroadcast=0;
    ACKDELAY=20;

    XS_AddSystemLoopFun(UserLoop);
       
    // Initialize Web server Kernal
    XS_Http_StartHttpServer();  // Add Web server
    XS_Http_SetDefaultFile("index.htm");    // Set the default response file
    XS_Http_AddCgi("usercgi", cgi_fun);     // Add CGI function
                
    // Add UDP search function
    XS_AddUdpSocket(&XS_UdpSearch);
    bAcceptBroadcast=1;
    
    MAXTXTOUT=6000UL;
    EnableWDT();
    
    XS_AddSystemLoopFun(XS_SocketLoopFun);
    XS_StartSocket();
}

void XS_UserEnd(void)
{
    XS_StopSocket();
    DisableWDT();
}

void UserLoop(void)
{
    RefreshWDT();
    
    if(Kbhit())
        if(Getch()=='q') QuitMain=1;
}

void main(int argc, char *argv[])
{
    XS_main(argc, argv);    // call the XS library main function
}